<?php
/*
Plugin Name: E-Mail Notification
Version: 1.4
Plugin URI: http://www.briangroce.com/archives/2004/07/word-press-email-notification-plugin-v14/
Description: Allow People To Sign Up For E-Mail Notifications
Author: Brian Groce
Author URI: http://briangroce.com/
*/

// add_action(hook, action, priority)
// [priority 0-10 with 0 being the highest priority]
add_action('publish_post', 'send_notification', 5);

function send_notification($post_ID)  {

    //********************************************************//
    //                   MAILLIST SETTINGS
    //********************************************************//

      # CONFIG SECTION

      # Database Information
      $db     = 'DATABASE';
      $dbuser = 'DATABASE USERNAME';
      $dbpass = 'DATABASE PASSWORD';
      $dbhost = 'localhost';               // localhost is default
      $email_tablename = 'wp_email_list';  // wp_email_list is default
      $posts_tablename = 'wp_posts';

      # Site Information
      $site_name = 'YOUR SITE NAME';
      $site_url = 'http://yoursite.com';
      $blog_url = 'http://yoursite.com/wordpress/';
      $from_email = 'you@yoursite.com';

      # Other Settings
      $nice_urls = 'no';     // yes or no
      $show_content = 'no'; // yes or no - send the entire post in email

      # END CONFIG SECTION

    //********************************************************//
    //                   GRAB POST STATUS
    //********************************************************//
		$prev_status = $_POST['prev_status'];
		$post_status = $_POST['post_status'];

		if (isset($_POST['publish'])) $post_status = 'publish';

		//********************************************************//
		// are we going from draft/private to published?
		//********************************************************//
		if ($prev_status != 'publish' && $post_status == 'publish') {

	    //********************************************************//
	    //               SELECT TITLE FROM DB
	    //********************************************************//
	    $query = "SELECT post_title, post_content FROM $posts_tablename WHERE ID = '$post_ID'";
      $res = mysql_query($query);
	    $row = mysql_fetch_assoc($res);

	    $post_title = stripslashes($row['post_title']);
      $post_title = str_replace(array("“","?","’","–","—","…"), array('"','"','','','','...'), $post_title);
      $post_title = utf8_decode($post_title);

	    $post_content = stripslashes($row['post_content']);
      $post_content = str_replace(array("“","?","’","–","—","…"), array('"','"','','','','...'), $post_content);
      $post_content = utf8_decode($post_content);
      $post_content = str_replace(array("<ul>","</ul>","<ol>","</ol>","<li>","</li>"), array('','','','','* ',''), $post_content);
      $post_content = strip_tags($post_content);

	    //********************************************************//
	    //                      BUILD URL
	    //********************************************************//

			if ($post_title != '' && $nice_urls == 'yes'){
	    	// This is for the nicer URL permalink
		    $url = get_permalink($post_ID);
				}

	    else {
	      // This is for the default URL permalink
	      $url = "$blog_url/index.php?p=$post_ID";
	      }

	    //********************************************************//
	    //             SELECT USERS TO EMAIL FROM DB
	    //********************************************************//

	    $query = "SELECT email_addr FROM $email_tablename WHERE gets_mail = 1";

	    $res = mysql_query($query);

	    while ($row = mysql_fetch_assoc($res)) {
	        $addr = $row['email_addr'];

				if ($post_title != ''){
					$msg =  "A new entry titled '$post_title' has been posted to $site_name.\n\n";
					}

				else {
					$msg =  "A new entry has been posted to $site_name.\n\n";
					}

        if ($show_content == 'yes') {
          $msg .= "$post_content\n\n";
          }

  	      $msg .= "$url\n\n";
  	      $msg .= "------------------------------------------------------\n\n";
					$msg .= "You have signed up to receive these notifications. \n\n";
					$msg .= "If you would like to unsubscribe, visit the url below:\n";

	        if ($nice_urls == 'yes'){
	          // This is for the nicer URL permalink
	          $msg .= "$site_url/maillist/unsub/$addr\n";
	          }

	        else {
	          // This is for the default URL permalink
	          $msg .= "$site_url/maillist/index.php?action=unsub&addr=$addr\n";
	          }

					$header = "From: $site_name <$from_email>\n";
          $header .= "Reply-To: $from_email\n";
          $header .= "Return-Path: $from_email\n";
          $header .= "MIME-Version: 1.0\n";

					if ($post_title != ''){
						Mail($addr, "$site_name: $post_title", $msg, $header);
						}

					else {
						Mail($addr, "$site_name: New Untitled Entry", $msg, $header);
						}
	    }

		} // end if moving from draft/private to published


    return $post_ID;  // It may be buggy otherwise.

}

?>